# coding=utf-8

""" Пакет для работы с нечетким, байесовским и детерминистическми логическим выводом.

В задачах математического моделирования часто возникает задача описания переменных, представляющих качественные
значения показателей, слабо формализуемых в дискретный набор значений. Примером таких показателей может служить
качество товара, эффективность работы учреждения, квалификация сотрудников и многие другие. В то же время,
традиционно уровни таких показателей оцениваются качественно, с использованием экспертных оценок, формулируемых
с помощью лингвистических понятий «низкий», «высокий», «очень высокий». Оперирование лингвистическими понятиями
представляет определенную сложность, преодоление которой требует привлечения определенного математического аппарата.

В пакете используется язык DOT для представления графов, язык FML для представления нечеткого контроля.

"""


_author__ = 'sejros'
__version__ = '0.4.0'
